# Tomo Standard Library

This directory contains all of the standard library functionality that is built
into each Tomo program. It has all the logic for core datastructures as well as
some common functionality.

## Core Functions

- Tomo headers all in one place: [header](stdlib/tomo.h)
- Tomo standard library functions: [header](stdlib/stdlib.h), [implementation](stdlib/stdlib.c)
- Metamethods: [header](stdlib/metamethods.h), [implementation](stdlib/metamethods.c)
- Siphash: [header](stdlib/siphash.h), [implementation](stdlib/siphash.c)
- Siphash-internals: [header](stdlib/siphash-internals.h), [implementation](stdlib/siphash-internals.c)
- Util: [header](stdlib/util.h), [implementation](stdlib/util.c)

## Core Data Types

- Datatypes (type definitions): [header](stdlib/datatypes.h), [implementation](stdlib/datatypes.c)
- Arrays: [header](stdlib/arrays.h), [implementation](stdlib/arrays.c)
- Bools: [header](stdlib/bools.h), [implementation](stdlib/bools.c)
- Bytes: [header](stdlib/bytes.h), [implementation](stdlib/bytes.c)
- C Strings: [header](stdlib/c_strings.h), [implementation](stdlib/c_strings.c)
- Files (used internally only): [header](stdlib/files.h), [implementation](stdlib/files.c)
- Functiontype: [header](stdlib/functiontype.h), [implementation](stdlib/functiontype.c)
- Integers: [header](stdlib/integers.h), [implementation](stdlib/integers.c)
- Memory: [header](stdlib/memory.h), [implementation](stdlib/memory.c)
- Nums: [header](stdlib/nums.h), [implementation](stdlib/nums.c)
- Optionals: [header](stdlib/optionals.h), [implementation](stdlib/optionals.c)
- Paths: [header](stdlib/paths.h), [implementation](stdlib/paths.c)
- Patterns: [header](stdlib/patterns.h), [implementation](stdlib/patterns.c)
- Pointers: [header](stdlib/pointers.h), [implementation](stdlib/pointers.c)
- Tables: [header](stdlib/tables.h), [implementation](stdlib/tables.c)
- Text: [header](stdlib/text.h), [implementation](stdlib/text.c)
- Threads: [header](stdlib/threads.h), [implementation](stdlib/threads.c)
- Type Infos (for representing types as values): [header](stdlib/types.h), [implementation](stdlib/types.c)
